/*  File FFPCTR.C Reads a pattern file and creates a training file  */

#ifndef FFPCTR_C
#define FFPCTR_C

#include <conio.h>
#include <alloc.h>
#include <stdio.h>

#include "ut.h"
#include "ffpr.h"

void create_training_file(ff_setup_rec setup,pattern_display_data *disp_data);

/*  Implementation  */

void create_training_file(ff_setup_rec setup,pattern_display_data *disp_data){
     int i,j,no_of_training_items = 0;
     FILE *outfile;
     pattern_array *the_patterns;
     f_vector x,d_out;
     clrscr();
     textcolor (YELLOW);
     gotoxy (1,1);
     cputs ("Neural Net Pattern Recognition Training File Program");
     gotoxy (1,3);
     if (setup.files.training_file_name[0] == '\0') {
	cprintf ("\r\nOutput Training file name is blank.\r\n");
	cputs ("Press key to cancel: ");
	getch();
	return;
	}
     if (setup.files.data_file_name[0] == '\0') {
	cprintf ("\r\nInput Data file name is blank.\r\n");
	cputs ("Press key to cancel: ");
	getch();
	return;
	}
     cprintf ("Output training file name: %s",setup.files.training_file_name);
     gotoxy (1,5);
     cprintf ("Input pattern data file name: %s",setup.files.data_file_name);
     gotoxy (1,7);
     cprintf ("Network Nodes (Input, Output): %3d   %2d",
	 setup.no_of_inputs,setup.no_of_outputs);
     gotoxy (1,10);
     cputs ("Press any key to start (esc to cancel): ");
     if (getch() == ESC_KEY) return;
     if (!open_output_text_file (&outfile,
	  setup.files.training_file_name)) return;
     the_patterns = (pattern_array *)malloc((size_t)sizeof(pattern_array));
     x = allocate_f_vector (1,setup.no_of_inputs);
     d_out = allocate_f_vector (1,setup.no_of_outputs);
     clrscr();
     if (!read_patterns (disp_data,setup.files.data_file_name,
	*the_patterns)) goto exit_proc;
     fprintf (outfile,"%3d  %2d\n",setup.no_of_inputs,
	 setup.no_of_outputs);
     fprintf (outfile,"minimum\n");
     for (i = 1;i<=setup.no_of_inputs;i++)
	 fprintf (outfile,"%2d\n",NODE_LOW);
     for (i = 1;i<=setup.no_of_outputs;i++)
	 fprintf (outfile,"%5.2f\n",0.0);
     fprintf (outfile,"maximum\n");
     for (i = 1;i<=setup.no_of_inputs;i++)
	 fprintf (outfile,"%2d\n",NODE_HIGH);
     for (i = 1;i<=setup.no_of_outputs;i++)
	 fprintf (outfile,"%5.2f\n",1.0);
     fprintf (outfile,"training data\n");
     for (i = 0;i<disp_data->no_of_patterns;i++) {
	 for (j = 1;j<=setup.no_of_inputs;j++)
	     x[j] = (*the_patterns)[i].nodes[j-1];
	 no_of_training_items++;
	 for (j = 1;j<=setup.no_of_inputs;j++)
	     fprintf (outfile,"%5.2f\n",x[j]);
	 for (j = 1;j<=setup.no_of_outputs;j++)
	     d_out [j] = 0.0;
	 d_out[no_of_training_items] = 1.0;
	 for (j = 1;j<=setup.no_of_outputs;j++)
	     fprintf (outfile,"%5.2f\n",d_out[j]);
	 gotoxy (1,11);
	 cputs ("                    ");
	 gotoxy (1,11);
	 cprintf ("%d training items done.",no_of_training_items);
      }  /*  i  */

     fclose (outfile);
     gotoxy (1,16);
     cputs ("Done.");
     gotoxy (1,18);
     cputs("Press key to clear: ");
     getch();
exit_proc:
     free_f_vector (x,1);
     free_f_vector (d_out,1);
     free (the_patterns);
     textmode (LASTMODE);
     }  /*  procedure  */

#endif