/*  File FFPDATA.C  Create new pattern data file  */

#ifndef FFPDATA_C
#define FFPDATA_C

#include <conio.h>
#include <alloc.h>

#include "ffpr.h"

void create_new_data_file (ff_setup_rec setup,pattern_display_data *disp_data);

/*  Implementation  */

void create_new_data_file (ff_setup_rec setup,pattern_display_data *disp_data)
    {
     pattern_array  *the_patterns;
     char ch = ' ';
     clrscr();
     textcolor (YELLOW);
     gotoxy (1,5);
     cputs ("Create New Pattern Data File");
     gotoxy (1,7);
     if (setup.files.new_data_file_name[0] == '\0') {
	cprintf ("\r\nOutput Data file name is blank.\r\n");
	cputs ("Press key to cancel: ");
	getch();
	return;
	}
     cprintf ("File Name for Storing New Pattern Data: %s",
       setup.files.new_data_file_name);
     gotoxy (1,9);
     cprintf ("Number of Pattern Rows: %d",disp_data->no_of_rows);
     gotoxy (1,10);
     cprintf ("Number of Pattern Columns: %d",disp_data->no_of_cols);
     gotoxy (1,11);
     cprintf ("Number of Patterns: %d",disp_data->no_of_patterns);
     disp_data->no_of_nodes = disp_data->no_of_cols * disp_data->no_of_rows;
     gotoxy (1,14);
     cputs ("Press any key to continue (esc to cancel): ");
     if (getch() == ESC_KEY) return;
     the_patterns = (pattern_array *)malloc((size_t)sizeof(pattern_array));
     create_new_patterns (disp_data,*the_patterns);
     clrscr();
     do {
	gotoxy (1,5);
	cputs ("Do want to make any changes before saving? Y/N: ");
	ch = getch();
	} while ((ch!='Y')&&(ch!='y')&&(ch!='N')&&(ch!='n'));
     if ((ch=='Y')||(ch=='y'))
	edit_pattern_file (disp_data,*the_patterns);
     clrscr();
     gotoxy (1,5);
     cputs ("Writing patterns to file...");
     write_patterns (disp_data,setup.files.new_data_file_name,*the_patterns);
     gotoxy (1,8);
     cprintf ("Patterns saved to file %s.",setup.files.new_data_file_name);
     gotoxy (1,10);
     cputs ("Press key to continue: ");
     getch();
     free (the_patterns);
     textmode (LASTMODE);
     }  /* procedure  */

#endif