// File FFPRSYS.CPP Pattern Recognition Feedforward Network
//               Turbo Vision interface

#include <conio.h>

extern "C" {
   #include "ffpr.h"
   }

#include "ffprsetp.cpp"

void handle_system (system_response *control_flag)
  {
   tffprsetapp *Setup_App = new tffprsetapp();
   quit_flag = quit;
   if (*control_flag == startup) {
      g_ff_setup.error_threshold = 0.01;
      g_ff_setup.no_of_inputs = 100;
      g_ff_setup.no_of_h1_nodes = 16;
      g_ff_setup.no_of_outputs = 5;
      g_ff_setup.sigmoid_out = TRUE;
      g_pattern_data.no_of_patterns = 5;
      g_pattern_data.no_of_rows = 10;
      g_pattern_data.no_of_cols = 10;
      g_pattern_data.no_of_nodes = g_pattern_data.no_of_rows *
	 g_pattern_data.no_of_cols;
      }
   Setup_App->run();
   Setup_App->destroy (Setup_App);
   *control_flag = quit_flag;
   return;
   }

int main()
   {
   system_response prog_control = startup;
   initialize_ff_setup (&g_ff_setup);
   strcpy (system_name,"Pattern Recognition");
   display_startup_message();
   do
   {
   handle_system(&prog_control);
   switch (prog_control) {
   case train_net:
	train_network_from_data (g_ff_setup,
	     &backpropagation_training);
	break;
   case training_data:
	create_training_file (g_ff_setup,&g_pattern_data);
	break;
   case run_net:
	run_pattern_network (g_ff_setup,&g_pattern_data);
	break;
   case edit_data:
	edit_data_file (g_ff_setup,&g_pattern_data);
	break;
   case new_data:
	create_new_data_file (g_ff_setup,&g_pattern_data);
	break;
   }
   } while (prog_control != quit);
   return 0;
   } // end main