/* File GA_ALG.C Genetic Alorithm  */

#ifndef GA_ALG_C
#define GA_ALG_C

#include <stdio.h>
#include <conio.h>
#include <alloc.h>

#include "ut.h"
#include "ga.h"

f_vector g_ga_max;

void genetic_algorithm (tga_setup_rec *setup,tga_rec *ga,
   float (*the_obj_funct)(ui_vector v)) {
   int gen = 0,i;
   short cancel_flag,new_optimum,within_tolerance;
   clrscr();
   textcolor (YELLOW);
   /* g_ga_max stores 'dynamic range' in each position, that is, it */
   /* stores the largest integer that can be handled by the algorithm, */
   /* as determined by power_of_two (bit_len). */
   g_ga_max = allocate_f_vector (0,setup->vect_len - 1);
   for (i=0;i<setup->vect_len;i++)
       g_ga_max[i] = power_of_2(setup->bit_len);
   if (!initialize_genetic_alg (setup,ga,the_obj_funct)) return;
   do {
      gen++;
      generation (setup,ga,the_obj_funct);
      statistics (*setup,ga->populations[ga->g_new],ga,&new_optimum);
      display (gen,*setup,*ga,&cancel_flag,&within_tolerance);
      ga->g_old = (ga->g_old + 1)%2;
      ga->g_new = (ga->g_new + 1)%2;
   } while ((gen <= setup->max_gens) && (!within_tolerance)
	    && (!cancel_flag));
   cprintf ("\r\nDone.  Press key to clear: ");
   getch();
   textmode (LASTMODE);
   free_ga_pointers (*setup,ga);
   free_f_vector (g_ga_max,0);
   return;
   } /* end proc */
#endif
