/*  File HOP.H  Header file for Hopfield network system */

#ifndef HOP_H
#define HOP_H

#include "pattern.h"
#include "ui.h"

typedef struct {
	file_names_rec files;
	int no_of_rows,no_of_cols,no_of_patterns;
	} hop_setup_rec;

extern hop_setup_rec g_hop_rec;

/*  HOPWTS.C  */
void initialize_hop_setup (hop_setup_rec *the_setup,
   pattern_display_data *disp_data);
short read_xmp_patterns (hop_setup_rec *the_setup,
   pattern_display_data *disp_data,path_str the_file_name,
   pattern_array the_patterns);
int **allocate_2d_int_matrix (int rows_lower_lim,int rows_upper_lim,
   int cols_lower_lim,int cols_upper_lim);
void free_2d_int_matrix (int **a,int rows_lower_lim,int cols_lower_lim);
void compute_hop_weights (pattern_display_data *disp_data,
   pattern_array the_patterns,int **weights);
short write_hop_weights (path_str file_name, int **w,int no_of_nodes);
short read_hop_weights (path_str file_name,int **w,int no_of_nodes);

/*  File HOPTRAIN.C  */
void create_new_xmp_data_file (hop_setup_rec *the_setup,
    pattern_display_data *disp_data);
void edit_xmp_data_file (hop_setup_rec *the_setup,
   pattern_display_data *disp_data);
void train_hopfield_network (hop_setup_rec *the_setup,
   pattern_display_data *disp_data);
void print_inner_products (hop_setup_rec *the_setup,
   pattern_display_data *disp_data);

/* File HOPRUN.C */
void run_hopfield_network (hop_setup_rec *the_setup,
   pattern_display_data *disp_data);

#endif