/*  File SLBFILES.C  Read and write weights files  */

#ifndef SLBFILES_C
#define SLBFILES_C

#include <conio.h>
#include "ut.h"
#include "slfbrm.h"

short read_weights (float ****w_in,float ***w_out,slb_setup_rec s);
short write_weights (float ****w_in,float ***w_out,slb_setup_rec s);

/* Implementation */

short read_weights (float ****w_in,float ***w_out,slb_setup_rec s) {
   /* Returns 1 if read OK, 0 if unsuccessful  */
   cprintf ("\r\n\nReading weights...\r\n");
   if (!read_4d_matrix (w_in,s.the_files.in_wts_file_name,s.lattice_rows,
      s.lattice_cols,s.lattice_k,NO_OF_INP_WTS)) return 0;
   if (!read_3d_matrix (w_out,s.the_files.out_wts_file_name,s.lattice_rows,
      s.lattice_cols,s.lattice_k)) return 0;
   return 1;
   }

short write_weights (float ****w_in,float ***w_out,slb_setup_rec s) {
   /* Returns 1 if write OK, 0 if unsuccessful  */
   cprintf ("\r\n\nWriting weights...\r\n");
   if (!write_4d_matrix (w_in,s.lattice_rows,s.lattice_cols,s.lattice_k,
	  NO_OF_INP_WTS,s.the_files.in_wts_file_name)) return 0;
   if (!write_3d_matrix (w_out,s.lattice_rows,s.lattice_cols,s.lattice_k,
	  s.the_files.out_wts_file_name)) return 0;
   return 1;
   }

#endif