/* File TRN.H  Header file for reading, storing and writing training files */

#ifndef TRN_H
#define TRN_H

#include "uttypes.h"

typedef struct {
   short allocated;  /* TRUE if allocated, else FALSE */
   int no_of_training_items;
   float no_of_training_items_inv,norm_error_scaling;
   f_vector *training_array,*correct_answers,*norm_answers;
   short max_min_allocated; /* TRUE if max & min allocated, else FALSE */
   f_vector max_in,min_in,max_out,min_out;
   } training_rec;

extern training_rec g_tr_rec;

/*  File TRNPROCS.C  */
void free_training_pointers (training_rec *tr_rec);
short process_training_file (path_str the_file_name,int no_of_inputs,
   int no_of_outputs,training_rec *tr_rec);
void normalize_data (f_vector x,f_vector norm_x,int no_of_pts,
   f_vector x_max,f_vector x_min,float norm_range,float norm_min);
void normalize_training_set (int no_of_inputs,int no_of_outputs,
   float norm_in_range,float norm_in_min,float norm_out_range,
   float norm_out_min,training_rec tr_rec);
void denormalize_output (f_vector y,f_vector denorm_out,int no_of_outputs,
   float norm_out_range,float norm_out_min,training_rec tr_rec);

#endif
